import java.util.Vector;
/**
 * This represents an unlimited length integer
 * 
 * @author Kent Archie 
 * @version 1.0
 */
public class BigNum
{
    Vector V;
    /** Constructor for objects of class BigNum */
    public BigNum() { V = new Vector(); }
    public BigNum(String str)
    {
       V = new Vector(str.length(),10);
       for(int i=str.length()-1; i >= 0; i--) {
          V.addElement(new Digit(str.charAt(i)));
       } // for
    } // string constructor

    public int size() { return V.size(); }
    public boolean isEmpty() { return V.size() == 0; }
    public void addDigit(int n) { V.addElement(new Digit(n)); }

    public BigNum reverse()
    {
        BigNum me = new BigNum();
        for(int i=this.size()-1;i>=0;--i) {
        /*
        Digit d = (Digit)V.elementAt(i);
        int foo = d.getValue();
        me.addDigit(foo);
        */
            me.addDigit( ( (Digit)V.elementAt(i)).getValue());
    } // for
        return(me);
    } // reverse

    public BigNum add(BigNum other)
    {
        int partial,carry=0,one,two,three,l=0,r=0;
 
        int rlength=other.size(),llength=this.size();
        BigNum result=new BigNum();
 
        while(true) {
            one = (r < rlength) ? ((Digit)other.V.elementAt(r++)).getValue() : -1;
            two = (l < llength) ? ((Digit)this.V.elementAt(l++)).getValue() : -1;
            if((one == -1) && (two == -1)) { // both done
                if(carry > 0)
                    result.addDigit(carry);
                return result;
//                return result.reverse();
            }
            three = one + two + carry;
            if(one == -1) // copy rest of two
                three = two + carry;            
            if(two == -1) // copy rest of one
                three = one + carry; 

            if(three >= 10) {
                carry=1;
                three -= 10;
            }
            result.addDigit(three);
        } // while
    } // add
    
    public String toString()
    {
        StringBuffer str = new StringBuffer(size());
        if(isEmpty()) return new String("");
        for(int i=size()-1;i>=0;i--)
            str.append( ( (Digit)V.elementAt(i)).getValue() );
        return str.toString();
    } // toString
}
