import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

/*
 * Created on Feb 9, 2004
 * This represents the process of adding data to a file.
 * It creates the file and holds the file object.
 * The data is added piece by piece.
 * If the file cannot be created or if a write operation
 * fails, ith throws exceptions.
 */

/**
 * @author Kent
 */
public class storage {
	DataOutputStream data;  // file to hold the data
	String fname;  // filename
	
	// use a default name for the file
	public storage() throws CreateFailed
	{
		createfile("files3.dat");
	} // objectstorage
	
	// create the file using the passed in name
	public storage(String name) throws CreateFailed
	{
		createfile(name);
	} // objectstorage
	
	private void createfile(String s) throws CreateFailed
	{	
		fname = new String(s); // save the filename
		File f = new File(fname);  // create the file object
		
		// if the files exists, don't overwrite
		if(f.exists()) {
			throw new CreateFailed(fname);
		}
		
		try {
			data = new DataOutputStream(new FileOutputStream(f));
		}
		catch(IOException e){
			throw new CreateFailed(fname);  // use our exception
		}
	} // createfile
	
	// add a record to the end of the file
	public void addrecord(info i) throws AddRecordFailed
	{
		try {
			data.writeUTF(i.getLast());  // last name
			data.writeUTF(i.getFirst()); // first name
			data.writeUTF(i.getState()); // state initials
			data.writeInt(i.getYear());  // year in school
		} catch(IOException e) {
			throw new AddRecordFailed(fname);
		}
	} // addrecord
	
	public void done()
	{
		try {
			data.close();
		} 
		catch(IOException e) {
			System.out.println("closing data file failed");
		}
	} // done
} // objectstorage class
