import java.io.BufferedReader;
import java.io.IOException;

// represents the common information and actions
// that all objects in the library must have
// We won't create any instances of this class
abstract class Holding
{
   protected String title;
   protected float cost;
   protected int location;
   
   public Holding (BufferedReader b) throws IOException
   {
      try {
          	System.out.print("Holding: Enter the Title ");
		title = b.readLine();
		System.out.print("Holding: Enter the Cost ");
		cost = Float.parseFloat(b.readLine());
		System.out.print("Holding: Enter the Location ");
		location = Integer.parseInt(b.readLine());
      } catch(IOException e) {
          System.out.println("Holding reading failed");
          throw e;
      }
   } // constructor
   public String toString ()
   {
      String result = "Title: " + title + "\n";
      result += "Cost: " + cost + "\n";
      result += "Location: " + location;
      return result;
   }
} // Holding
