import java.io.BufferedReader;
import java.io.IOException;

// represents a video object for the collection
class Video extends Holding
{
   protected String director;
   protected float length;  // in minutes
   
   public Video (BufferedReader b) throws IOException
   {
      super(b);  // get the basic title,cost and location data
      try {
          	System.out.print("Video: Enter the Directors name ");
		director = b.readLine();
		System.out.print("Book: Enter the length ");
		length = Float.parseFloat(b.readLine());
      } catch(IOException e) {
	  // report what we were entering then re-raise the
	  // exception so the main program can handle it
          System.out.println("video reading failed");
          throw e;
      }
   } // constructor


   public String toString ()
   {
      String result = super.toString();  // get the basic info first

      result += "\nDirector: " + director;
      result += "\nLength: " + length;

      return result;
   }
} // Video
