
import javax.swing.Box;
//import javax.swing.JOptionPane;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
/**
 * This represents a set of traffic lights
 * 
 * @author kent archie 
 * @version 2/4/2004
 */
public class lights
{
    private Box lightpanel;
    private light[] signals;  // array of light objects
    boolean running = true;   // controls the simulation run
    boolean turnon = false;   // turn signal on?
    
    /**
     * Constructor for objects of class lights
     */
    public lights()
    {
        signals = new light[4];  // create array of light objects
        
		lightpanel = Box.createVerticalBox();
		lightpanel.setBorder(new TitledBorder(
							     new EtchedBorder(),
									 "Traffic Lights"));
		// create the light objects for each light type
		signals[constants.RED] = new light(constants.RED); 
		signals[constants.YELLOW] = new light(constants.YELLOW);	
		signals[constants.GREEN] = new light(constants.GREEN);	
		signals[constants.TURN] = new light(constants.TURN);
		for(int i=0; i<4; i++)  // add them all to the panel
			lightpanel.add(signals[i].getpanel());										 
    } // lights
    
    public Box getpanel() { return lightpanel; }
    
    public void lighton(int light) 
    {
    	if((light < 0) || (light > 4)) return;
    	signals[light].lighton();
	   	lightpanel.repaint();
    } // lighton
    
	public void lightoff(int light) 
	{
		if((light < 0) || (light > 4)) return;
		signals[light].lightoff();
		lightpanel.repaint();
	} // lightoff
	
//	public void simon() { running = true; run(); }  // turn on the simulation
	public void simoff() { running = false;}  // turn off the simulation
	public void turnsignal() {  // turn signal should be used
//		JOptionPane.showMessageDialog(null, "Turn button pressed");
		turnon = true; 
	} 
	
	public void go()
	{
		lighton(constants.RED); // red on
		try {
			while(running) {
				if(turnon) { // light up the turn signal for half the time				
					Thread.sleep(constants.DELAY/2);
//					JOptionPane.showMessageDialog(null, "Turn signal on"); 
					lighton(constants.TURN);
					Thread.sleep(constants.DELAY/2);
				}
				else {
					Thread.sleep(constants.DELAY);	
				}
				lightoff(constants.RED); // red off
				if(turnon) { // turn signal off
					lightoff(constants.TURN);
//					JOptionPane.showMessageDialog(null, "Turn signal off");
					turnon = false;
				}
				lighton(constants.GREEN); // green on
				Thread.sleep(constants.DELAY);	
				
				lightoff(constants.GREEN); // green off
				lighton(constants.YELLOW); // yellow on
				Thread.sleep(constants.DELAY);	
				
				lightoff(constants.YELLOW); // yellow off
				lighton(constants.RED); // red on
			} // while
		} catch(InterruptedException e){}
	} // run
} // lights
