import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

/*
 * Created on Feb 12, 2004
 */

/**
 * @author Kent
 */
public class gui extends JFrame{
	private final int NUMYEARS=4;   // number of radio buttons
	private Container c;   // the frame contents
	private JPanel buttons;   // holds the control buttons
	private JButton clear;    // clear the fields for a new entry
	private JButton save;     // save this entry
	private JButton print;     // done, print values
	
	private JPanel names;     // holds the name text fields
	private JTextField fname; // get the first name
	private JTextField lname; // get the last name
	
	private String[] states = {"IL","WI","IA","MI","IN","MN"};
	private JPanel others;    // holds the state and year things
	private JPanel yeargroup; // holds the year buttons
	
	private JComboBox state;
	
	private storage folder;  // current storage object
	private JRadioButton[] rbutton = new JRadioButton[NUMYEARS];  // placeholder
	private int year;   // what year was selected
	
	public gui(storage s)
	{
		super("Student Info");
		setVisible(true);
		setSize(400,400);      // set frame size
		c=getContentPane();
		folder = s;
		
		makeButtons();   // set up the button controls
		makeNames();	 // set up the name fields
		makeOthers();	 // year buttons and state list
		
		c.setLayout(new BorderLayout());
		c.add(names,BorderLayout.NORTH); 
		c.add(others,BorderLayout.CENTER); 
		c.add(buttons,BorderLayout.SOUTH);
		show();
	} // default constructor
	
	//		set up the names panel
	private void makeNames()
	{
		names = new JPanel();
		names.setLayout(new FlowLayout());
		
		JPanel f = new JPanel();  // hold first name and label
		JPanel l = new JPanel();  // hold lastname and label
		f.setLayout(new FlowLayout());
		l.setLayout(new FlowLayout());
		f.add(new JLabel("First Name:"));
		l.add(new JLabel("Last Name:"));

		// create the text fields and make them 5 columns long
		// then add them to the panel
		fname = new JTextField(5); f.add(fname);
		lname = new JTextField(5); l.add(lname);
		names.add(f); names.add(l);
	} // makeNames
	
	//		create the control buttons
	private void makeButtons()
	{
		buttons = new JPanel();

		buttons.setLayout(new FlowLayout());
		clear = new JButton("Clear");
		clear.setToolTipText("Reset the fields");
		clear.addActionListener(new controllisten());
		
		save = new JButton("Next");
		save.setToolTipText("Save the record");
		save.addActionListener(new controllisten());
		
		print = new JButton("Print");
		print.setToolTipText("Print the data");
		print.addActionListener(new controllisten());
		
		// add the buttons to the panel
		buttons.add(clear); buttons.add(save); buttons.add(print);	
	} // makeButtons
	
	//		set up the years and state panel		
	private void makeOthers()
	{
	 	ButtonGroup years; // year choices		
		others = new JPanel();
		others.setLayout(new FlowLayout());
		
		// create a box panel to hold the label and the list
		Box b = new Box(BoxLayout.Y_AXIS);  // 
		b.add(new JLabel("State"));
		state = new JComboBox(states); // use the string array to populate the list
		state.setSelectedIndex(0);   // IL is default
		b.add(state);
	
		// create a box panel to hold the label and the year buttons
		Box y = new Box(BoxLayout.Y_AXIS);
		years = new ButtonGroup();
		yeargroup = new JPanel();  // put the buttons in their own panel
		yeargroup.setLayout(new FlowLayout());
		/* make NUMYEAR radio buttons
		 * first create a button using the loop index as the label
		 * then add the button to the butongroup. This causes only one to
		 * be selected. add the button to the panel so it shows up
		 * on the display. Finally create an action listener for the button.
		 * We could have created one actionlistener and used it for all the buttons
		 */
		for(int i=0; i < NUMYEARS; i++) {
			rbutton[i] = new JRadioButton(Integer.toString(i+1));
			years.add(rbutton[i]);  yeargroup.add(rbutton[i]); // add to panel
			rbutton[i].addActionListener(new controllisten());
		} // for
		y.add(new JLabel("Year In School"));
		y.add(yeargroup);
		
		others.add(b); others.add(y);
	} // makeOthers
	
	// this action listener is used for all the buttons
	private class controllisten implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			Object source = event.getSource();  // who sent the action?
			if(source == clear) {  // was it the clear button?
				fname.setText("");	lname.setText("");
				state.setSelectedIndex(0);
			}
			else
			if(source == save) {  // was it the save button?
				// create a new info object and pass it to the storage object
				info i = new info(fname.getText(), // get first name
				                  lname.getText(), // get last name
				                  (String)state.getSelectedItem(),
				                  year
				                  );
				try {
					folder.addData(i);  // this adds the info to the vector
				}catch(AddRecordFailed e) {
					System.out.println("Adding record for " +e.getLastName() + " failed");
					System.exit(1);
				}
				// clear the fields after it is saved
				fname.setText("");	lname.setText("");
				state.setSelectedIndex(0);
			}
			else
			if(source == print) {  // was it the quit button?
				folder.printData();  // print to standard out
			}
			else {
				// check which year button was clicked
				for(int i =0; i < NUMYEARS; i++) {
					if(source == rbutton[i])
						year = i+1;  // save the value
				} // for
			}	 // else radio buttons	
		} // actionPerformed
	} // controllisten
} // gui class
