import java.util.*;

/*
 * Created on Feb 12, 2004
 */

/**
 * @author Kent
 * This manages the Vector of data objects we will be using
 * 
 */
public class storage {
	private final int DEFAULTSIZE=6;  // default vector size
	private  Vector v;  // this will hold our data objects.
	
	public storage()
	{
		// create vector with 6 slots to start
		// just references created, no objects yet
		v = new Vector(DEFAULTSIZE); 
	} // default constructor
	
	public storage(int size)
	{
		// create vector with size slots to start
		// just references created, no objects yet
		v = new Vector(size); 
	} // one arg constructor
	
	public void addData(info i) throws AddRecordFailed{
		try {
			v.add(i);  // put the record in the next open slot
		} catch(ArrayIndexOutOfBoundsException e) {
			throw new AddRecordFailed(i.getLast());
		  }
	} //addData
	
	// retrieve the element at location i
	public info getData(int i)
	{
		info joe;
		try {
				joe = (info) v.get(i);
			} catch(ArrayIndexOutOfBoundsException e) {
				System.out.println("There is no element " + i);
				return null;
			  }
		return joe;
	} // getData
	
	// demonstrates an iterator
	public void printData()
	{
		Iterator it = v.iterator();
		// it now refers top the first element in the vector
		// hasnext() returns true is there is another element or false
		// if there isn't
		while(it.hasNext()) {
			// next() returns the next thing in the vector
			// it returns an Object. You may have to cast it to
			// use it.it Here we are calling toString() and Object has one
			// so we don't need to cast it. It will call the one for
			// the actual class, not the Object. next() wil also
			// move the iterator so it is ready to get the next one.
			System.out.println(it.next()); 
		}		
	} // printData
} // storage